from student import Student
from fag import Fag


class Studentsystem:
    def __init__(self):
        self._studenter = []
        self._fag = []

    def lesFraFil(self, fil):
        nyttFag = None
        for linje in open(fil):
            linje = linje.rstrip()
            if linje[0] == "*":
                nyttFag = Fag(linje[1:])
                self._fag.append(nyttFag)

            else:
                if not self.finnStudent(linje):
                    nyStudent = Student(linje)
                    self._studenter.append(nyStudent)
                    nyttFag.leggTilStudent(nyStudent)
                    nyStudent.leggTilFag(nyttFag)
                else:
                    studenten = self.finnStudent(linje)
                    nyttFag.leggTilStudent(studenten)
                    studenten.leggTilFag(nyttFag)


    def finnStudent(self, studentNavn):
        for student in self._studenter:
            if student.hentStudentNavn() == studentNavn:
                return student

    def finnFag(self, fagNavn):
        for fag in self._fag:
            if fag.hentFagNavn() == fagNavn:
                return fag

    def skrivFagTilStudent(self):
        studentNavn = input("Skriv inn studentnavn: ")
        student = self.finnStudent(studentNavn)
        if student != None:
            student.skrivFagPaaStudent()
        else:
            print("Studenten finnes ikke.")

    def skrivStudenterTilFag(self):
        fagNavn = input("Skriv inn fagnavn: ")
        fag = self.finnFag(fagNavn)
        if fag != None:
            fag.skrivStudenterVedFag()
        else:
            print("Faget finnes ikke.")

    def finnStudentMedFlestFag(self):
        antFlest = 0
        studentFlest = None
        for student in self._studenter:
            if student.hentAntallFag() > antFlest:
                antFlest = student.hentAntallFag()
                studentFlest = student
        if studentFlest == None:
            print("Ingen studenter har noen fag")
        else:
            print("Studenten som har flest fag er", studentFlest.hentStudentNavn(), "han eller hun har", antFlest, "fag")

    def finnFagMedFlestStudenter(self):
        antFlest = 0
        fagFlest = None
        for fag in self._fag:
            if fag.hentAntallStudenter() > antFlest:
                antFlest = fag.hentAntallStudenter()
                fagFlest = fag
        if fagFlest == None:
            print("Ingen fag har noen studenter. ")
        else:
            print("Faget som har flest studenter er", fagFlest.hentFagNavn(), "det har", antFlest, "studenter")

    def leggTilStudent(self):
        navn = input("Skriv inn studentens navn: ")
        nyStudent = Student(navn)
        if self.finnStudent(navn) == None:
            self._studenter.append(nyStudent)
        else:
            print("Studenten finnes allerede i systemet")

    def leggTilFag(self):
        fagNavn = input("Skriv ut fagets navn: ")
        nyttFag = Fag(fagNavn)
        if self.finnFag(fagNavn) == None:
            self._fag.append(nyttFag)
        else:
            print("Faget finnes allerede i systemet")

    def registrerStudentTilFag(self):
        fagNavn = input("Skriv inn fagnavn: ")
        studentNavn = input("Skriv inn studentens navn: ")
        fag = self.finnFag(fagNavn)
        student = self.finnStudent(studentNavn)
        if fag == None or student == None:
            print("Fag eller student finnes ikke i systemet")
        elif not student.tarFag(fag):
            fag.leggTilStudent(student)
            student.leggTilFag(fag)
        else:
            print("Studenten har allerede faget.")

    def skrivMeny(self):
        print("Skriv 's' for aa legge til student.")
        print("Skriv 'f' for aa legge til fag.")
        print("Skriv 'sfts' for aa skrive fag til student.")
        print("Skriv 'sstf' for aa skrive studenter til fag")
        print("Skriv 'fil' for aa lese fra fil.")
        print("Skriv 'rsf' for aa registrere student til fag.")
        print("Skriv 'sff' for aa finne student med flest fag.")
        print("Skriv 'ffs' for aa finne fag med flest studenter.")
        print("Skriv 'q' for aa stoppe programmet.")
